function test(k,l,iter)

    g = falses(k,l+2)
    t = 0               # time
    s = 0               # speed

    # the bottom two auxilary layers (they will always be blue)
    for i = 1:k
        for j = 1:2
            g[i,j] = true
        end
    end

    # compute the `anti-power' of a vertex (prob it does not turn white neighbours blue)
    function prob_turning(i,j)
        if ( (i < 1) || (i > k) || (j < 1) || (j > l+2) || (g[i,j] == false) )
            return 1
        end

        p = 1
        if ( (i-1 >= 1) && (g[i-1,j] == true) )
            p += 1
        end
        if ( (i+1 <= k) && (g[i+1,j] == true) )
            p += 1
        end
        if ( (j+1 <= l+2) && (g[i,j+1] == true) )
            p += 1
        end
        if ( (j-1 >= 1) && (g[i,j-1] == true) )
            p += 1
        end
        return 1-p/4
    end

    # compute the probability that a vertex turns blue
    function prob_blue(i,j)
        return 1 - prob_turning(i-1,j) * prob_turning(i+1,j) * prob_turning(i,j-1) * prob_turning(i,j+1)
    end

    function one_step()
        h = falses(k,l+2)
        for i = 1:k
            for j = 3:l+2
                if (g[i,j] == true)
                    h[i,j] = true
                else
                    if (rand() < prob_blue(i,j))
                        h[i,j] = true
                    end
                end
            end
        end
        for i = 1:k
            for j = 3:l+2
                g[i,j]=h[i,j]
            end
        end
        t += 1
    end

    function move_window()
        while true
            for i = 1:k
                if (g[i,3] == false)
                    return
                end
            end
            for i = 1:k
                for j = 3:l+1
                    g[i,j] = g[i,j+1]
                end
                g[i,l+2] = false
            end
            s += 1
        end
    end

    while t < iter
        one_step()
        move_window()
        if t % 10^4 == 0
            println("t = ", t, " speed = ", s/t, " upper bound = ", (t/s+1)/2)
        end
    end
end

test(40, 10, 10^5)
