# second implementation (for large n)

# integer number of position 1-based
function int2pos(i, n)
    i -= 1
    return ntuple(x -> (i & (1 << (n - x))) >> (n - x), n)
end

# 1-0 tuple encoding position
function pos2int(t)
    i = 0
    for v in t
        i = (i << 1) + v
    end
    return i + 1
end

# all positions of length n
extended(n) = Iterators.product(fill([0,1], n)...) |> collect |> vec

function getprob_app2(n)
    @assert 2 <= n <= 15
    ext = extended(n)
    ext1 = extended(n+1)
    return getprob_app2(n, ext, ext1)
end

function getprob_app2(n, ext, ext1)
    @assert 2 <= n <= 15
    mat = zeros(Float64, length(ext), length(ext))

    if n == 2 || isodd(n)
        mat[1, pos2int(ntuple(i -> abs(i - ((n + 1) ÷ 2)) <= 1 ? 1 : 0, n))] = 1/1
    else
        mat[1, pos2int(ntuple(i -> abs(i - ((n + 1) ÷ 2)) <= 1 ? 1 : 0, n))] = 1/2
        mat[1, pos2int(ntuple(i -> abs(i - ((n + 3) ÷ 2)) <= 1 ? 1 : 0, n))] = 1/2
    end
    for i in 2:2^n
        t = int2pos(i, n)
        for j in 1:2^(n+1)
            t1 = ext1[j]
            p1 = (1.0)
            if t1[1] == 1
                if t[1] == 1
                    p1 *= 3/4
                else
                    p1 = 0.0
                end
            else
                if t[1] == 1
                    p1 *= 1/4
                end
            end

            if t1[end] == 1
                if t[end] == 1
                    p1 *= 3/4
                else
                    p1 = 0.0
                end
            else
                if t[end] == 1
                    p1 *= 1/4
                end
            end

            for k in 2:n
                if t1[k] == 1
                    if t[k-1] == 1
                        if t[k] == 1
                            p1 *= 15/16
                        else
                            p1 *= 3/4
                        end
                    else
                        if t[k] == 1
                            p1 *= 3/4
                        else
                            p1 = 0.0
                        end
                    end
                else
                    if t[k-1] == 1
                        if t[k] == 1
                            p1 *= 1/16
                        else
                            p1 *= 1/4
                        end
                    else
                        if t[k] == 1
                            p1 *= 1/4
                        end
                    end
                end
            end

            if t1[1] == 1
                if t1[end] == 1
                    mat[i, pos2int(t1[1:end-1])] += p1 / 2
                    mat[i, pos2int(t1[2:end])] += p1 / 2
                else
                    mat[i, pos2int(t1[1:end-1])] += p1
                end
            else
                if t1[end] == 1
                    mat[i, pos2int(t1[2:end])] += p1
                else
                    mat[i, pos2int(t1[1:end-1])] += p1 / 2
                    mat[i, pos2int(t1[2:end])] += p1 / 2
                end
            end
        end
    end
    return mat
end

using QuantEcon
@time m = getprob_app2(15); @time x = stationary_distributions(MarkovChain(m))[1][1]; (x, count(==(0), m) / length(m)) # run 1
@time m = getprob_app2(16); @time x = stationary_distributions(MarkovChain(m))[1][1]; (x, count(==(0), m) / length(m)) # run 2
